package org.apache.bcel.generic;

import org.apache.bcel.ExceptionConst;
import org.apache.bcel.ExceptionConst.EXCS;

public class PUTSTATIC extends FieldInstruction implements ExceptionThrower, PopInstruction {
   PUTSTATIC() {
   }

   public PUTSTATIC(int index) {
      super((short)179, index);
   }

   public void accept(Visitor v) {
      v.visitExceptionThrower(this);
      v.visitStackConsumer(this);
      v.visitPopInstruction(this);
      v.visitTypedInstruction(this);
      v.visitLoadClass(this);
      v.visitCPInstruction(this);
      v.visitFieldOrMethod(this);
      v.visitFieldInstruction(this);
      v.visitPUTSTATIC(this);
   }

   public int consumeStack(ConstantPoolGen cpg) {
      return this.getFieldSize(cpg);
   }

   public Class<?>[] getExceptions() {
      return ExceptionConst.createExceptions(EXCS.EXCS_FIELD_AND_METHOD_RESOLUTION, new Class[]{ExceptionConst.INCOMPATIBLE_CLASS_CHANGE_ERROR});
   }
}
